PF-build.sh 36 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_14
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. #### Start check if OSTYPE is supported
  123. OS_FOUND=$( command -v uname)
  124. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  125. linux*)
  126. TARGET_OS="linux"
  127. ;;
  128. msys*|cygwin*|mingw*)
  129. # or possible 'bash on windows'
  130. TARGET_OS='windows'
  131. ;;
  132. nt|win*)
  133. TARGET_OS='windows'
  134. ;;
  135. *)
  136. TARGET_OS='unknown'
  137. ;;
  138. esac
  139. # Windows
  140. if [ $TARGET_OS == "windows" ]; then
  141. if [ $(uname -m) == "x86_64" ]; then
  142. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  143. Processor="64"
  144. elif [ $(uname -m) == "i386" ]; then
  145. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  146. Processor="32"
  147. else
  148. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  149. echo "Please refer to the notes of build.sh$(tput sgr0)"
  150. exit 1
  151. fi
  152. # Linux
  153. elif [ $TARGET_OS == "linux" ]; then
  154. if [ $(uname -m) == "x86_64" ]; then
  155. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  156. Processor="64"
  157. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  158. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  159. Processor="32"
  160. else
  161. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  162. echo "Please refer to the notes of build.sh$(tput sgr0)"
  163. exit 1
  164. fi
  165. else
  166. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  167. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  168. echo "Read the notes of build.sh$(tput sgr0)"
  169. exit 1
  170. fi
  171. sleep 2
  172. #### End check if OSTYPE is supported
  173. #### Prepare bash environment and check if wget, zip and other needed things are available
  174. # Check wget
  175. if ! type wget > /dev/null; then
  176. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  177. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  178. exit 2
  179. fi
  180. # Check for zip
  181. if ! type zip > /dev/null; then
  182. if [ $TARGET_OS == "windows" ]; then
  183. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  184. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  185. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  186. echo "Run git Bash under Administrator privilege and"
  187. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  188. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  189. exit 3
  190. elif [ $TARGET_OS == "linux" ]; then
  191. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  192. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  193. exit 3
  194. fi
  195. fi
  196. # Check python ... needed during language build
  197. if ! type python > /dev/null; then
  198. if [ $TARGET_OS == "windows" ]; then
  199. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  200. exit 4
  201. elif [ $TARGET_OS == "linux" ]; then
  202. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  203. echo "As Python 2.x will not be maintained from 2020 please,"
  204. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  205. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  206. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  207. exit 4
  208. fi
  209. fi
  210. #### End prepare bash / Linux environment
  211. #### Set build environment
  212. ARDUINO_ENV="1.8.5"
  213. BUILD_ENV="1.0.6"
  214. BOARD="prusa_einsy_rambo"
  215. BOARD_PACKAGE_NAME="PrusaResearch"
  216. BOARD_VERSION="1.0.3"
  217. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  218. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  219. BOARD_FILENAME="prusa3dboards"
  220. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  221. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  222. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  223. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  224. LIB="PrusaLibrary"
  225. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  226. # List few useful data
  227. echo
  228. echo "Script path :" $SCRIPT_PATH
  229. echo "OS :" $OS
  230. echo "OS type :" $TARGET_OS
  231. echo ""
  232. echo "Ardunio IDE :" $ARDUINO_ENV
  233. echo "Build env :" $BUILD_ENV
  234. echo "Board :" $BOARD
  235. echo "Package name:" $BOARD_PACKAGE_NAME
  236. echo "Board v. :" $BOARD_VERSION
  237. echo "Specific Lib:" $LIB
  238. echo ""
  239. #### Start prepare building environment
  240. #Check if build exists and creates it if not
  241. if [ ! -d "../PF-build-dl" ]; then
  242. mkdir ../PF-build-dl || exit 5
  243. fi
  244. cd ../PF-build-dl || exit 6
  245. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  246. # Check if PF-build-env-<version> exists and downloads + creates it if not
  247. # The build environment is based on the supported Arduino IDE portable version with some changes
  248. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  249. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  250. mkdir ../PF-build-env-$BUILD_ENV
  251. sleep 5
  252. fi
  253. # Download and extract supported Arduino IDE depending on OS
  254. # Windows
  255. if [ $TARGET_OS == "windows" ]; then
  256. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  257. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  258. sleep 2
  259. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  260. echo "$(tput sgr 0)"
  261. fi
  262. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  263. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  264. sleep 2
  265. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  266. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  267. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  268. echo "$(tput sgr0)"
  269. fi
  270. fi
  271. # Linux
  272. if [ $TARGET_OS == "linux" ]; then
  273. # 32 or 64 bit version
  274. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  275. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  276. sleep 2
  277. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  278. echo "$(tput sgr 0)"
  279. fi
  280. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  281. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  282. sleep 2
  283. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  284. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  285. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  286. echo "$(tput sgr0)"
  287. fi
  288. fi
  289. # Make Arduino IDE portable
  290. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  291. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  292. fi
  293. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  294. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  295. fi
  296. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  297. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  298. fi
  299. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  300. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  301. fi
  302. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  303. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  304. fi
  305. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  306. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  307. fi
  308. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  309. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  310. fi
  311. # Change Arduino IDE preferences
  312. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  313. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  314. sleep 2
  315. echo "update.check"
  316. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  317. echo "board"
  318. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  319. echo "editor.linenumbers"
  320. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  321. echo "boardsmanager.additional.urls"
  322. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  323. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  324. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  325. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  326. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  327. echo "$(tput sgr0)"
  328. fi
  329. # Download and extract Prusa Firmware related parts
  330. # Download and extract PrusaResearchRambo board
  331. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  332. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  333. sleep 2
  334. wget $BOARD_FILE_URL || exit 9
  335. fi
  336. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  337. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  338. sleep 2
  339. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  340. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  341. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  342. fi
  343. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  344. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  345. fi
  346. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  347. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  348. fi
  349. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  350. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  351. fi
  352. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  353. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  354. echo "$(tput sgr 0)"
  355. fi
  356. # Download and extract Prusa Firmware specific library files
  357. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  358. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  359. sleep 2
  360. wget $PF_BUILD_FILE_URL || exit 11
  361. echo "$(tput sgr 0)"
  362. fi
  363. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  364. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  365. sleep 2
  366. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  367. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  368. echo "$(tput sgr0)"
  369. fi
  370. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  371. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  372. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  373. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  374. sleep 2
  375. fi
  376. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  377. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  378. sleep 2
  379. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  380. sleep 2
  381. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  382. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  383. echo "$(tput sgr0)"
  384. fi
  385. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  386. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  387. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  388. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  389. sleep 2
  390. echo "$(tput sgr0)"
  391. exit 13
  392. fi
  393. #### End prepare building
  394. #### Start
  395. cd $SCRIPT_PATH
  396. # First argument defines which variant of the Prusa Firmware will be compiled
  397. if [ -z "$1" ] ; then
  398. # Select which variant of the Prusa Firmware will be compiled, like
  399. PS3="Select a variant: "
  400. while IFS= read -r -d $'\0' f; do
  401. options[i++]="$f"
  402. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  403. select opt in "${options[@]}" "All" "Quit"; do
  404. case $opt in
  405. *.h)
  406. VARIANT=$(basename "$opt" ".h")
  407. VARIANTS[i++]="$opt"
  408. break
  409. ;;
  410. "All")
  411. VARIANT="All"
  412. VARIANTS=${options[*]}
  413. break
  414. ;;
  415. "Quit")
  416. echo "You chose to stop"
  417. exit
  418. ;;
  419. *)
  420. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  421. ;;
  422. esac
  423. done
  424. else
  425. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  426. VARIANTS=$1
  427. else
  428. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  429. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  430. echo "$(tput sgr0)"
  431. exit 21
  432. fi
  433. fi
  434. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  435. #Check default language mode
  436. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  437. if [ -z "$2" ] ; then
  438. PS3="Select a language: "
  439. echo
  440. echo "Which lang-build do you want?"
  441. select yn in "Multi languages" "English only"; do
  442. case $yn in
  443. "Multi languages")
  444. LANGUAGES="ALL"
  445. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  446. break
  447. ;;
  448. "English only")
  449. LANGUAGES="EN_ONLY"
  450. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  451. break
  452. ;;
  453. *)
  454. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  455. ;;
  456. esac
  457. done
  458. else
  459. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  460. LANGUAGES=$2
  461. else
  462. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  463. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  464. exit 22
  465. fi
  466. fi
  467. #Check if DEV_STATUS is selected via argument 3
  468. if [ ! -z "$3" ] ; then
  469. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  470. DEV_STATUS_SELECTED=$3
  471. else
  472. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  473. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  474. exit 23
  475. fi
  476. fi
  477. #Set BUILD_ENV_PATH
  478. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  479. BUILD_ENV_PATH="$( pwd -P )"
  480. cd ../..
  481. #Checkif BUILD_PATH exists and if not creates it
  482. if [ ! -d "Prusa-Firmware-build" ]; then
  483. mkdir Prusa-Firmware-build || exit 25
  484. fi
  485. #Set the BUILD_PATH for Arduino IDE
  486. cd Prusa-Firmware-build || exit 26
  487. BUILD_PATH="$( pwd -P )"
  488. for v in ${VARIANTS[*]}
  489. do
  490. VARIANT=$(basename "$v" ".h")
  491. # Find firmware version in Configuration.h file and use it to generate the hex filename
  492. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  493. # Find build version in Configuration.h file and use it to generate the hex filename
  494. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  495. # Check if the motherboard is an EINSY and if so only one hex file will generated
  496. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  497. # Check development status
  498. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  499. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  500. if [[ "$DEV_CHECK" == "RC1" || "$DEV_CHECK" == "RC2" || "$DEV_CHECK" == "RC3" ]] ; then
  501. DEV_STATUS="RC"
  502. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  503. DEV_STATUS="ALPHA"
  504. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  505. DEV_STATUS="BETA"
  506. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  507. DEV_STATUS="DEVEL"
  508. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  509. DEV_STATUS="DEBUG"
  510. else
  511. DEV_STATUS="UNKNOWN"
  512. echo
  513. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  514. PS3="Select YES only if source code is tested and trusted: "
  515. select yn in "Yes" "No"; do
  516. case $yn in
  517. Yes)
  518. DEV_STATUS="GOLD"
  519. DEV_STATUS_SELECTED="GOLD"
  520. break
  521. ;;
  522. No)
  523. DEV_STATUS="UNKNOWN"
  524. DEV_STATUS_SELECTED="UNKNOWN"
  525. break
  526. ;;
  527. *)
  528. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  529. ;;
  530. esac
  531. done
  532. fi
  533. else
  534. DEV_STATUS=$DEV_STATUS_SELECTED
  535. fi
  536. #Prepare hex files folders
  537. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  538. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  539. fi
  540. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  541. #Check if exactly the same hexfile already exists
  542. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  543. echo ""
  544. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  545. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  546. read -t 10 -p "Press Enter to continue..."
  547. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  548. echo ""
  549. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  550. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  551. read -t 10 -p "Press Enter to continue..."
  552. fi
  553. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  554. echo ""
  555. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  556. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  557. read -t 10 -p "Press Enter to continue..."
  558. fi
  559. #List some useful data
  560. echo "$(tput setaf 2)$(tput setab 7) "
  561. echo "Variant :" $VARIANT
  562. echo "Firmware :" $FW
  563. echo "Build # :" $BUILD
  564. echo "Dev Check :" $DEV_CHECK
  565. echo "DEV Status :" $DEV_STATUS
  566. echo "Motherboard:" $MOTHERBOARD
  567. echo "Languages :" $LANGUAGES
  568. echo "Hex-file Folder:" $OUTPUT_FOLDER
  569. echo "$(tput sgr0)"
  570. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  571. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  572. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  573. else
  574. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  575. read -t 10 -p "Press Enter to continue..."
  576. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  577. fi
  578. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  579. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  580. # set FW_REPOSITORY
  581. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  582. #Prepare english only or multilanguage version to be build
  583. if [ $LANGUAGES == "ALL" ]; then
  584. echo " "
  585. echo "Multi-language firmware will be built"
  586. echo " "
  587. else
  588. echo " "
  589. echo "English only language firmware will be built"
  590. echo " "
  591. fi
  592. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  593. # if [ $TARGET_OS == "windows" ]; then
  594. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  595. # fi
  596. #### End of Prepare building
  597. #### Start building
  598. export ARDUINO=$BUILD_ENV_PATH
  599. #echo $BUILD_ENV_PATH
  600. #export BUILDER=$ARDUINO/arduino-builder
  601. echo
  602. #read -t 5 -p "Press Enter..."
  603. echo
  604. echo "Start to build Prusa Firmware ..."
  605. echo "Using variant $VARIANT$(tput setaf 3)"
  606. sleep 2
  607. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  608. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  609. echo "$(tput sgr 0)"
  610. if [ $LANGUAGES == "ALL" ]; then
  611. echo "$(tput setaf 2)"
  612. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  613. echo "$(tput sgr 0)"
  614. sleep 2
  615. cd $SCRIPT_PATH/lang
  616. echo "$(tput setaf 3)"
  617. ./config.sh || exit 31
  618. echo "$(tput sgr 0)"
  619. # Check if previous languages and firmware build exist and if so clean them up
  620. if [ -f "lang_en.tmp" ]; then
  621. echo ""
  622. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  623. read -t 10 -p "Press Enter to continue..."
  624. echo "$(tput setaf 3)"
  625. ./lang-clean.sh
  626. echo "$(tput sgr 0)"
  627. fi
  628. if [ -f "progmem.out" ]; then
  629. echo ""
  630. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  631. read -t 10 -p "Press Enter to continue..."
  632. echo "$(tput setaf 3)"
  633. ./fw-clean.sh
  634. echo "$(tput sgr 0)"
  635. fi
  636. # build languages
  637. echo "$(tput setaf 3)"
  638. ./lang-build.sh || exit 32
  639. # Combine compiled firmware with languages
  640. ./fw-build.sh || exit 33
  641. echo "$(tput sgr 0)"
  642. # Check if the motherboard is an EINSY and if so only one hex file will generated
  643. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  644. # If the motherboard is an EINSY just copy one hexfile
  645. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  646. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  647. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  648. else
  649. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  650. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  651. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  652. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  653. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  654. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  655. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  656. if [ $TARGET_OS == "windows" ]; then
  657. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  658. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  659. elif [ $TARGET_OS == "linux" ]; then
  660. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  661. fi
  662. fi
  663. # Cleanup after build
  664. echo "$(tput setaf 3)"
  665. ./fw-clean.sh || exit 34
  666. ./lang-clean.sh || exit 35
  667. echo "$(tput sgr 0)"
  668. else
  669. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  670. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  671. fi
  672. # Cleanup Firmware
  673. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  674. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  675. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  676. echo $MULTI_LANGUAGE_CHECK
  677. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  678. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  679. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  680. sleep 5
  681. done
  682. # Switch to hex path and list build files
  683. cd $SCRIPT_PATH
  684. cd ..
  685. echo "$(tput setaf 2) "
  686. echo " "
  687. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  688. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  689. #### End building